﻿using System;
using System.Collections.Generic;
using System.Threading;
using Wisej.Web;


namespace UserControlFlowLayout_Example
{
    public partial class Dashboard_Main : Page
    {
        List<Order> _Orders;

        List<string> _Customers;
        List<string> _Carriers;
        List<string> _Addresses;
        List<string> _Freights;
        List<string> _CustomerPrices;
        List<string> _CarrierPrices;
        public Dashboard_Main()
        {
            InitializeComponent();
        }

        private void Dashboard_Main_Load(object sender, EventArgs e)
        {
            PrepareLists();

            if (_Orders == null || _Orders.Count == 0)            {
                _Orders = new List<UserControlFlowLayout_Example.Order>();
                for (int i = 0; i < 50; i++)
                {
                    Order newOrder = new UserControlFlowLayout_Example.Order();
                    newOrder.OrderNumber = "No. 100" + new Random().Next(1000).ToString();
                    newOrder.Customer = _Customers[new Random().Next(_Customers.Count - 1)];
                    newOrder.Carrier = _Carriers[new Random().Next(_Carriers.Count - 1)];
                    newOrder.Address = _Addresses[new Random().Next(_Addresses.Count - 1)];
                    newOrder.Freight = _Freights[new Random().Next(_Freights.Count - 1)];
                    newOrder.CustomerPrice = _CustomerPrices[new Random().Next(_CustomerPrices.Count - 1)];
                    newOrder.CarrierPrice = _CarrierPrices[new Random().Next(_CarrierPrices.Count - 1)];

                    _Orders.Add(newOrder);

                    Thread.Sleep(15);
                }
            }

            FillFlowLayoutPanel();

        }
        private void PrepareLists()
        {
            if (_Customers == null)
                _Customers = new List<string> { "Volkswagen", "Audi", "BMW", "Mercedes", "Porsche" };

            if (_Carriers == null)
                _Carriers = new List<string> { "Czako Trans", "SML Cargo", "Fast-Trans", "Cargo_Sped", "Super Tarns Group" };

            if (_Addresses == null)
                _Addresses = new List<string> { "47179 Duisburg", "42929 Wermelskirchen", "54296 Trier", "80331 München", "38440 Wolfsburg" };

            if (_Freights == null)
                _Freights = new List<string> { "3 Pal. a 450 kg", "2 Gibo 100x200x50 = 300 kg", "10 Boxes = 50kg", "1 Pal. 1T" };

            if (_CustomerPrices == null)
                _CustomerPrices = new List<string> { "250.00€", "365.78€", "120.50€", "1450.00€", "768.79€", "319.00€" };

            if (_CarrierPrices == null)
                _CarrierPrices = new List<string> { "75.00€", "475.00€", "1075.00€", "575.00€", "175.00€", "750.00€" };
        }

        private void FillFlowLayoutPanel()
        {
            if (flowLayoutPanel1.Controls.ContainsKey("btn_More"))
                flowLayoutPanel1.Controls.RemoveByKey("btn_More");

            Application.StartTask(() =>
            {
                foreach (Order order in _Orders)
                {
                    try
                    {
                        CustomerControl custcon = new UserControlFlowLayout_Example.CustomerControl();
                        custcon.OrderNumber = order.OrderNumber;
                        custcon.Customer = order.Customer;
                        custcon.Carrier = order.Carrier;
                        custcon.Address = order.Address;
                        custcon.Freight = order.Freight;
                        custcon.CustomerPrice = order.CustomerPrice;
                        custcon.CarrierPrice = order.CarrierPrice;

                        flowLayoutPanel1.Controls.Add(custcon);
                        Application.Update(this);

                        Thread.Sleep(1);
                    }
                    catch (Exception ex)
                    { }
                }

                Button btn_More = new Button();
                btn_More.Name = "btn_More";
                btn_More.Width = 150;
                btn_More.Text = "Load more elements...";
                btn_More.Click += Btn_More_Click;
                flowLayoutPanel1.Controls.Add(btn_More);

                Application.Update(this);

                Thread.Sleep(1000);

                flowLayoutPanel1.VerticalScroll.Value = (flowLayoutPanel1.Controls.Count + 1) * 140;

                Application.Update(this);

                Thread.Sleep(1);
            });
        }


        private void Btn_More_Click(object sender, EventArgs e)
        {
            FillFlowLayoutPanel();
        }        
    }
}
